<div class="clients-list mb-5">

  <div class="container">

    <h1 class="mat-h1">Klienci</h1>
    <mat-divider class="mb-2"></mat-divider>

    <mat-card>
      <div class="search-div">
        <ng-container *ngIf="currentUser?.permissions?.canEditClients">
          <button mat-raised-button (click)="onCreateClientDialog()">
            <mat-icon>add</mat-icon>
            Dodaj klienta
          </button>
        </ng-container>
        <mat-form-field class="search-form-field">
          <input matInput [(ngModel)]="searchKey" placeholder="Wyszukaj klienta" autocomplete="off"
                 (keyup)="applyFilter()">
          <button mat-button matSuffix mat-icon-button aria-label="Wyczyść" *ngIf="searchKey" (click)="onSearchClear()">
            <mat-icon>close</mat-icon>
          </button>
        </mat-form-field>
      </div>

      <div class="mat-elevation-z8">
        <mat-table [dataSource]="clientsDataSource" matSort>

          <ng-container matColumnDef="name">
            <mat-header-cell *matHeaderCellDef>Nazwa</mat-header-cell>
            <mat-cell *matCellDef="let element">{{element?.name}}</mat-cell>
          </ng-container>

          <ng-container matColumnDef="regon">
            <mat-header-cell *matHeaderCellDef mat-sort-header>Regon</mat-header-cell>
            <mat-cell *matCellDef="let element">{{element?.regon}}</mat-cell>
          </ng-container>

          <ng-container matColumnDef="nip">
            <mat-header-cell *matHeaderCellDef mat-sort-header>Nip</mat-header-cell>
            <mat-cell *matCellDef="let element">{{element?.nip}}</mat-cell>
          </ng-container>

          <ng-container matColumnDef="address1">
            <mat-header-cell *matHeaderCellDef mat-sort-header>Adres 1</mat-header-cell>
            <mat-cell
              *matCellDef="let element">{{element?.address1}}</mat-cell>
          </ng-container>

          <ng-container matColumnDef="address2">
            <mat-header-cell *matHeaderCellDef mat-sort-header>Adres 2</mat-header-cell>
            <mat-cell
              *matCellDef="let element">{{element?.address2}}</mat-cell>
          </ng-container>

          <ng-container matColumnDef="contactPhoneNumber">
            <mat-header-cell *matHeaderCellDef mat-sort-header>Numer telefonu</mat-header-cell>
            <mat-cell *matCellDef="let element">{{element?.contactPhoneNumber}}</mat-cell>
          </ng-container>

          <ng-container matColumnDef="contactEmail">
            <mat-header-cell *matHeaderCellDef mat-sort-header>Email</mat-header-cell>
            <mat-cell *matCellDef="let element">{{element?.contactEmail}}</mat-cell>
          </ng-container>

          <ng-container matColumnDef="numberOfProjects">
            <mat-header-cell *matHeaderCellDef mat-sort-header>L. projektów</mat-header-cell>
            <mat-cell *matCellDef="let element">{{element?.numberOfProjects}}</mat-cell>
          </ng-container>

          <ng-container matColumnDef="numberOfClosedProjects">
            <mat-header-cell *matHeaderCellDef mat-sort-header>L. zamkn. projektów</mat-header-cell>
            <mat-cell *matCellDef="let element">{{element?.numberOfClosedProjects}}</mat-cell>
          </ng-container>

          <ng-container matColumnDef="actions">
            <mat-header-cell *matHeaderCellDef></mat-header-cell>
            <mat-cell *matCellDef="let row">
              <ng-container *ngIf="currentUser?.permissions?.canEditClients">
                <button mat-icon-button (click)="onUpdateClientDialog(row)">
                  <mat-icon matTooltip="Edytuj klienta">edit</mat-icon>
                </button>
                <button mat-icon-button color="warn" (click)="onRemoveClient(row)">
                  <mat-icon matTooltip="Usuń klienta">delete_outline</mat-icon>
                </button>
              </ng-container>
            </mat-cell>
          </ng-container>

          <ng-container matColumnDef="loading">
            <mat-footer-cell *matFooterCellDef>
              Ładowanie danych...
            </mat-footer-cell>
          </ng-container>
          <ng-container matColumnDef="noData">
            <mat-footer-cell *matFooterCellDef>
              Aktualnie brak danych o klientach w Twojej firmie.
            </mat-footer-cell>
          </ng-container>

          <mat-header-row *matHeaderRowDef="displayedColumns"></mat-header-row>
          <mat-row *matRowDef="let row; columns: displayedColumns;"></mat-row>

          <mat-footer-row *matFooterRowDef="['loading']"
                          [ngClass]="{'none':clientsDataSource!=null}"></mat-footer-row>
          <mat-footer-row *matFooterRowDef="['noData']"
                          [ngClass]="{'none':!(clientsDataSource!=null && clientsDataSource.data.length==0)}"></mat-footer-row>

        </mat-table>
        <mat-paginator [pageSizeOptions]="[5, 10, 25, 100]" [pageSize]="10" showFirstLastButtons></mat-paginator>
      </div>
    </mat-card>

  </div>
</div>
